version: '3.9'
services:
    nginx:
        image: nginx:latest
        ports: 
            - 81:80
        volumes:
            - type: volume
              source: html
              target: /usr/share/nginx/html
        networks:
            - servidores-web-networks            
        deploy:
          replicas: 10
          restart_policy:
            condition: on-failure
          update_config:
            parallelism: 2
            delay: 10s
            order: start-first #
          rollback_config:
            parallelism: 1
            delay: 10s
            order: start-first
          resources:
            limits:
                cpus: "0.1"
                memory: "50M"
          placement:
            constraints: 
              - node.role == manager
                    
    apache:
        image: httpd:2.4.51-alpine
        secrets:
            - secret-arquivo
        ports:
            - 82:80
        networks:
            - servidores-web-networks            
        deploy:
          replicas: 5
          resources:
            limits:
                cpus: "0.1"
                memory: "50M"
          placement:
              constraints: 
                  - node.role == manager
      
    tomcat:
        image: tomcat:alpine
        ports:
            - 83:8080
        networks:
            - servidores-web-networks
        deploy:
          replicas: 2
          resources:
            limits:
                cpus: "0.1"
                memory: "100M"
          placement:
              constraints: [ node.role == worker ]

secrets:
    secret-arquivo:
        file: secret.txt
              
volumes:
    html:
    
networks:
    servidores-web-networks:
        driver: overlay
    